=== debian/changelog ===
ros-eloquent-rcutils (0.8.5-1bionic) bionic; urgency=high

  * Update the maintainers. (#299 <https://github.com/ros2/rcutils/issues/299>)
  * check and link against libatomic (#172 <https://github.com/ros2/rcutils/issues/172>) (#178 <https://github.com/ros2/rcutils/issues/178>) (#217 <https://github.com/ros2/rcutils/issues/217>)
  * Contributors: Chris Lalancette, Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 04 Dec 2020 06:00:00 -0000

ros-eloquent-rcutils (0.8.4-1bionic) bionic; urgency=high

  * fix type of logging feature keys (#192 <https://github.com/ros2/rcutils/issues/192>)
  * Contributors: Dirk Thomas

 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 18 Nov 2019 06:00:00 -0000

ros-eloquent-rcutils (0.8.3-1bionic) bionic; urgency=high

  * Fix uninitialized handle error (#187 <https://github.com/ros2/rcutils/issues/187>)
  * Use Win32 wrapper around 64 bit atomic operations (#186 <https://github.com/ros2/rcutils/issues/186>)
  * Contributors: Sean Kelly

 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 12 Nov 2019 06:00:00 -0000

ros-eloquent-rcutils (0.8.2-1bionic) bionic; urgency=high

  * Specify working directory for filesystem test (#185 <https://github.com/ros2/rcutils/issues/185>)
  * Make use of time source type for throttling logs (#183 <https://github.com/ros2/rcutils/issues/183>)
  * Remove ready_fn - will be replaced by ReadyToTest() (#184 <https://github.com/ros2/rcutils/issues/184>)
  * Contributors: Brian Marchi, Dan Rose, Peter Baughman

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 23 Oct 2019 05:00:00 -0000

ros-eloquent-rcutils (0.8.1-1bionic) bionic; urgency=high

  * Implement rcutils_mkdir. (#166 <https://github.com/ros2/rcutils/issues/166>)
  * Contributors: Chris Lalancette

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 03 Oct 2019 05:00:00 -0000

ros-eloquent-rcutils (0.8.0-1bionic) bionic; urgency=high

  * Make g_rcutils_log_severity_names public and immutable. (#180 <https://github.com/ros2/rcutils/issues/180>)
  * use _WIN32 instead of WIN32 (#179 <https://github.com/ros2/rcutils/issues/179>)
  * Revert "check and link against libatomic (#172 <https://github.com/ros2/rcutils/issues/172>)" (#177 <https://github.com/ros2/rcutils/issues/177>)
  * check and link against libatomic (#172 <https://github.com/ros2/rcutils/issues/172>)
  * Rewrite test_logging_throttle tests: (#167 <https://github.com/ros2/rcutils/issues/167>)
  * Disable uncrustify indentation check for macros that use windows  __pragma (#164 <https://github.com/ros2/rcutils/issues/164>)
  * Fix armhf warning (#163 <https://github.com/ros2/rcutils/issues/163>)
  * Contributors: Christian Rauch, Dirk Thomas, Emerson Knapp, Michel Hidalgo, Shane Loretz, jpsamper2009

 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 24 Sep 2019 05:00:00 -0000

ros-eloquent-rcutils (0.7.3-1bionic) bionic; urgency=high

  * getprogname() is the correct API to use on Android. (#162 <https://github.com/ros2/rcutils/issues/162>)
  * Contributors: Chris Lalancette

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 29 May 2019 05:00:00 -0000

ros-eloquent-rcutils (0.7.1-1bionic) bionic; urgency=high

  * Add function rcutils_string_array_cmp (#144 <https://github.com/ros2/rcutils/issues/144>)
  * Rename result variable for clarity. (#157 <https://github.com/ros2/rcutils/issues/157>)
  * Add in utilities needed for log location (#155 <https://github.com/ros2/rcutils/issues/155>)
  * remove macros from source file (#156 <https://github.com/ros2/rcutils/issues/156>)
  * Migrate launch tests to new launch_testing features & API (#140 <https://github.com/ros2/rcutils/issues/140>)
  * Use GCC extension for printf-like functions (#154 <https://github.com/ros2/rcutils/issues/154>)
  * Fix leak in test_logging.cpp (#153 <https://github.com/ros2/rcutils/issues/153>)
  * Fix leak in test_logging_macros.cpp (#152 <https://github.com/ros2/rcutils/issues/152>)
  * Fix remaining leaks in test_string_map.cpp (#151 <https://github.com/ros2/rcutils/issues/151>)
  * Fix a leak in test_array_list.cpp (#149 <https://github.com/ros2/rcutils/issues/149>)
  * Contributors: Chris Lalancette, Dirk Thomas, Jacob Perron, Michel Hidalgo, Steven! Ragnarök, Thomas Moulard

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 08 May 2019 05:00:00 -0000

ros-eloquent-rcutils (0.7.0-1bionic) bionic; urgency=high

  * Fix ASAN failure in test_string_map.cpp (#147 <https://github.com/ros2/rcutils/issues/147>)
  * Add tests for stdatomic_helper.h and fix bugs (#150 <https://github.com/ros2/rcutils/issues/150>)
  * Windows messages when atomic type is unsupported (#145 <https://github.com/ros2/rcutils/issues/145>)
  * Use CMake property to determine when to use memory_tools. (#139 <https://github.com/ros2/rcutils/issues/139>)
  * Add section about DCO to CONTRIBUTING.md
  * Use ament_target_dependencies where possible. (#137 <https://github.com/ros2/rcutils/issues/137>)
  * Fix doc typo in string_map.h. (#138 <https://github.com/ros2/rcutils/issues/138>)
  * Add launch along with launch_testing as test dependencies. (#136 <https://github.com/ros2/rcutils/issues/136>)
  * Drops legacy launch API usage. (#134 <https://github.com/ros2/rcutils/issues/134>)
  * Contributors: Dirk Thomas, Jacob Perron, Michel Hidalgo, Shane Loretz, Steven! Ragnarök, Thomas Moulard, ivanpauno

 -- Karsten Knese <karsten@osrfoundation.org>  Sat, 13 Apr 2019 05:00:00 -0000

ros-eloquent-rcutils (0.6.2-1bionic) bionic; urgency=high

  * Adding an ArrayList and HashMap implementation to rcutils (#131 <https://github.com/ros2/rcutils/issues/131>)
  * Change uncrustify max line length to 0 (#133 <https://github.com/ros2/rcutils/issues/133>)
  * Contributors: Jacob Perron, Nick Burek

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 07 Feb 2019 06:00:00 -0000

ros-eloquent-rcutils (0.6.1-1bionic) bionic; urgency=high

  * Logging (#127 <https://github.com/ros2/rcutils/issues/127>)

